#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "_bootstrap4xi.py">
#<abstract4xi abstract = "providing function _bootstrap4xi"/>
#<refer4xi reference = "process.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------
 
# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ '_bootstrap4xi']  
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread 
import _winapi

import signal
import itertools

#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.process import Process
except:
    print("_bootstrap4xi.py *** failed in from multiprocessing.process import process ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from current_process4xi import set_current_process4xi
from current_process4xi import get_current_process4xi
from _exit_function4xi import _exit_function4xi
from _run_after_forkers4xi import _run_after_forkers4xi
from finalizer4xi import clear_finalizer_registry4xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>



 
# ---------------------------------------------------------------------------------------------
#<function4xi function = "bootstrap4xi" usage = "
#   forking.py:
#       code = process_obj._bootstrap()
#"> 
#<note4xi note = "embedded inside current_process4xi.py and mainprocess4xi.py"/>
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# ---------------------------------------------------------------------------------------------
#
def _bootstrap4xi(self): 
    '''
    offers boot strap services
    '''

    # -----------------------------------------------------------------------------------------    
    # (Step 1/24)
    # -----------------------------------------------------------------------------------------        

    class2xi = '_bootstrap4xi'
    method2xi = '_bootstrap4xi'
    
    message2print = "{started" + "; bootstrap4xi-started: " + str(_bootstrap4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
          
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        

    try:
                
        # -------------------------------------------------------------------------------------    
        # (Step 2/24)
        # -------------------------------------------------------------------------------------         
          
        self._children = set()
        
        message2print = "{(Step 2/24) set" + "; children-of-bootstrap4xi-set-by-bootstrap4xi to: " + str(self._children)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
                
        # -------------------------------------------------------------------------------------    
        # (Step 3/24)
        # -------------------------------------------------------------------------------------         
        
        self._counter = itertools.count(1)

        
        message2print = "{(Step 3/24) set" + "; counter-of-bootstrap4xi-set-by-bootstrap4xi to: " + str(self._counter)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
             
        # -------------------------------------------------------------------------------------    
        # (Step 4/24)
        # -------------------------------------------------------------------------------------         
        
        if sys.stdin is not None:
            try:
                # -----------------------------------------------------------------------------    
                # (Step 5/24)
                # -----------------------------------------------------------------------------              
                message2print = "{(Step 5/25a) passing" + "; sys-stdin-fileno-passing-to-os-close-by-bootstrap4xi: " + str(sys.stdin.fileno()) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)          
        
 
                os.close(sys.stdin.fileno())
                
                message2print = "{(Step 5/25a) performed" + "; os-close-performed-by-bootstrap4xi: " + str(os.close) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                        
            except (OSError, ValueError):
                # -----------------------------------------------------------------------------    
                # (Step 6/24)
                # -----------------------------------------------------------------------------              
                message2print = "{(Step 6/25a) hit" + "; OSError-hit-by-bootstrap4xi: " + " *** " + str(OSError)  + " *** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                
                message2print = "{(Step 6/25b) hit" + "; ValueError-hit-by-bootstrap4xi: " + " *** " + str(ValueError)  + " *** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                    
                
                pass
                
        # -------------------------------------------------------------------------------------    
        # (Step 7/24)
        # -------------------------------------------------------------------------------------         
        set_current_process4xi(self) #dragonized to set the global variable using function instead setting it directly
        
        message2print = "{(Step 7/24) set" + "; current-process4xi-set-by-bootstrap4xi to: " + str(get_current_process4xi())  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                
        # -------------------------------------------------------------------------------------    
        # (Step 8/24)
        # -------------------------------------------------------------------------------------         

        clear_finalizer_registry4xi()
        
        message2print = "{(Step 8/24) performed" + "; clear_finalizer_registry4xi-performed-by-bootstrap4xi: " + str(clear_finalizer_registry4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        
        # -------------------------------------------------------------------------------------    
        # (Step 9/24)
        # -------------------------------------------------------------------------------------         
      

        _run_after_forkers4xi()
        
        message2print = "{(Step 9/24) performed" + "; run-after-forkers4xi-performed-by-bootstrap4xi: " + str(_run_after_forkers4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                
        # -------------------------------------------------------------------------------------    
        # (Step 10/24)
        # -------------------------------------------------------------------------------------         
        
        # child process calling self.run()
        
        
        try:
        
            # ---------------------------------------------------------------------------------    
            # (Step 11/24)
            # ---------------------------------------------------------------------------------         

            self.run()
            
            message2print = "{(Step 11/24) performed" + "; run-of-bootstrap4xi-performed-by-bootstrap4xi: " + str(self.run) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                    
        
            # ---------------------------------------------------------------------------------    
            # (Step 12/24)
            # ---------------------------------------------------------------------------------         
                 
            
            exitcode = 0
        
            message2print = "{(Step 12/24) set" + "; exitcode-set-by-bootstrap4xi to: " + str(exitcode)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
   
   
        finally:
        
            # ---------------------------------------------------------------------------------    
            # (Step 13/24)
            # ---------------------------------------------------------------------------------         
                
            _exit_function4xi()
            
            message2print = "{(Step 13/24) performed" + "; _exit_function4xi-performed-by-bootstrap4xi: " + str(_exit_function4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                    
                        
    except SystemExit as e:
        if not e.args:
        
            # ---------------------------------------------------------------------------------    
            # (Step 14/24)
            # ---------------------------------------------------------------------------------         
             
            exitcode = 1
            
            message2print = "{(Step 14/24) set" + "; exitcode-set-by-bootstrap4xi to: " + str(exitcode)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                    
            
        elif type(e.args[0]) is int:
        
            # ---------------------------------------------------------------------------------    
            # (Step 15/24)
            # ---------------------------------------------------------------------------------         
             
            exitcode = e.args[0]
            
            message2print = "{(Step 15/24) set" + "; exitcode-set-by-bootstrap4xi to: " + str(exitcode)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
        else:
        
            # ---------------------------------------------------------------------------------    
            # (Step 16/24)
            # ---------------------------------------------------------------------------------         
             
            sys.stderr.write(e.args[0] + '\n')
            
            message2print = "{(Step 16/24) performed" + "; sys-stderr-write-performed-by-bootstrap4xi: " + str(sys.stderr.write) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                    
        
            # ---------------------------------------------------------------------------------    
            # (Step 17/24)
            # ---------------------------------------------------------------------------------         
                 
            sys.stderr.flush()
            
            message2print = "{(Step 17/24) performed" + "; sys-stderr-flush-performed-by-bootstrap4xi: " + str(sys.stderr.flush) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                
            # ---------------------------------------------------------------------------------    
            # (Step 18/24)
            # ---------------------------------------------------------------------------------         
                 
            exitcode = 1
            
            message2print = "{(Step 18/24) set" + "; exitcode-set-by-bootstrap4xi to: " + str(exitcode)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            
    except:
        
        # -------------------------------------------------------------------------------------    
        # (Step 19/24)
        # -------------------------------------------------------------------------------------         
         
        exitcode = 1
        
        message2print = "{(Step 19/24) set" + "; exitcode-set-by-bootstrap4xi to: " + str(exitcode)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        # -------------------------------------------------------------------------------------    
        # (Step 20/24)
        # -------------------------------------------------------------------------------------         
             
        import traceback
        
        message2print = "{(Step 20/24) imported" + "; traceback-imported-by-bootstrap4xi: " + str(traceback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        # -------------------------------------------------------------------------------------    
        # (Step 21/24)
        # -------------------------------------------------------------------------------------         
             
        sys.stderr.write('_bootstrap4xi: Process %s:\n' % self.name)
        
        message2print = "{(Step 21/24) performed" + "; sys.stderr.write-performed-by-bootstrap4xi: " + str(sys.stderr.write) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                
        
        # -------------------------------------------------------------------------------------    
        # (Step 22/24)
        # -------------------------------------------------------------------------------------         
             
        sys.stderr.flush()
        
        message2print = "{(Step 22/24) performed" + "; sys-stderr-flush-performed-by-bootstrap4xi: " + str(sys.stderr.flush) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                
        # -------------------------------------------------------------------------------------    
        # (Step 23/24)
        # -------------------------------------------------------------------------------------         
             
        traceback.print_exc()
        
        
        message2print = "{(Step 23/24) performed" + "; traceback-print-exc-performed-by-bootstrap4xi: " + str(traceback.print_exc) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
            
    
        
    
    # -----------------------------------------------------------------------------------------    
    # (Step 24/24)
    # -----------------------------------------------------------------------------------------        
    # process exiting
    
    message2print = "{(Step 24/24) returning" + "; exitcode-returning-by-bootstrap4xi: " + str(exitcode) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
        
    
    return exitcode

#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_bootstrap4xi.txt
#   sense-test-bootstrap4xi.xml
#   reason-test-bootstrap4xi.xml
#   ace-test-bootstrap4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of _bootstrap4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
   